/*
 WSysTray was contributed to Absolute Power++:
   http://www.orbit.org/power/
 by Ivan Bowman. However, neither he, nor Powersoft take any
 responsibility whatsoever for this code or what you do with
 it - use it at your own risk. Similarly, neither Ivan Bowman
 nor Powersoft support this code, and will therefore not answer
 any questions regarding it.
*/

//
// WSysTray.hpp
//

/*************************************************************************
 *
 * WSysTray -- show an icon in the notification area of the taskbar.
 *
 *   Events:
 *
 *************************************************************************/

#ifndef _WSYSTRAY_HPP_INCLUDED
#define _WSYSTRAY_HPP_INCLUDED

#ifndef _WNO_PRAGMA_PUSH
#pragma pack(push,4);
#pragma enum int;
#endif

#ifndef _WWINDOW_HPP_INCLUDED
#include "wwindow.hpp"
#endif


class WCMCLASS WSysTray : public WWindow
{
   WDeclareSubclass( WSysTray, WWindow );

   public:

   /**************************************************************
       * Constructors and Destructors
    **************************************************************/

      WSysTray();

      ~WSysTray();

   /**************************************************************
       * Properties
    **************************************************************/

      // Icon
   //
   //    The icon to use in the notification area

      WBool SetIcon( const WIcon & icon );

      // Tip
   //
   //    The tooltip to use in the notification area

      WBool SetTip( const WChar * tip );

   /**************************************************************
       * Methods
    **************************************************************/

   //
   // Create
   //
   //    Create the tray icon.

      WBool Create( const WIcon & icon, const WChar * tip = NULL );



   /**************************************************************
       * Internal
    **************************************************************/

      virtual WBool ProcessMessage( const WMessage & msg, WLong & returns );

   private:

      WBool leftButtonDoubleEventHandler( WObject *, WEventData * );

      WBool destroyEventHandler( WObject *, WEventData * );

   private:
      WIcon   _icon;
      WString _tip;
};

#ifndef _WNO_PRAGMA_PUSH
#pragma enum pop;
#pragma pack(pop);
#endif


#endif // _WSYSTRAY_HPP_INCLUDED